
/*
A simple C++ wrapper around WIN32 WNDCLASSEX structure
Copyright (C) 2000 Antti Markus (antti@pld.ttu.ee)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "winclass.h"

#include <string.h>

TWindowClass::TWindowClass(void)
{
  memset(&WindowClass, 0, sizeof(WNDCLASSEX));
}

TWindowClass::TWindowClass(UINT Style, WNDPROC pCallback,
                           HINSTANCE hInst, HICON hIcon,
                           HICON hSmallIcon,
                           HBRUSH hBackground,
                           LPCTSTR pMenuName,
                           LPCTSTR pClassName)
{
  WindowClass.cbSize=sizeof(WNDCLASSEX);
  WindowClass.style=Style;
  WindowClass.lpfnWndProc=pCallback;
  WindowClass.cbClsExtra=0;
  WindowClass.cbWndExtra=0;
  WindowClass.hInstance=hInst;
  WindowClass.hIcon=hIcon;
  WindowClass.hCursor=LoadCursor(NULL, IDC_ARROW);
  WindowClass.hbrBackground=hBackground;
  WindowClass.lpszMenuName=pMenuName;
  WindowClass.lpszClassName=pClassName;
  WindowClass.hIconSm=hSmallIcon;
}

TWindowClass::TWindowClass(UINT Style, WNDPROC pCallback,
                           HINSTANCE hInst, HICON hIcon,
                           HICON hSmallIcon,
                           HBRUSH hBackground,
                           WORD MenuID,
                           LPCTSTR pClassName)
{
  WindowClass.cbSize=sizeof(WNDCLASSEX);
  WindowClass.style=Style;
  WindowClass.lpfnWndProc=pCallback;
  WindowClass.cbClsExtra=0;
  WindowClass.cbWndExtra=0;
  WindowClass.hInstance=hInst;
  WindowClass.hIcon=hIcon;
  WindowClass.hCursor=LoadCursor(NULL, IDC_ARROW);
  WindowClass.hbrBackground=hBackground;
  WindowClass.lpszMenuName=MAKEINTRESOURCE(MenuID);
  WindowClass.lpszClassName=pClassName;
  WindowClass.hIconSm=hSmallIcon;
}

ATOM TWindowClass::Register(void)
{
  return RegisterClassEx(&WindowClass);
}
